/*Zofia Kruczkiewicz, p.325 C3
  Program prezentuje przekazywanie parametrow do funkcji przez:
  1) wartosc
  2) wskaznik
  3) referencje
  oraz zwracanie wyniku dzialania funkcji przez wartosc
  */

#include <stdio.h>
#include <conio.h>
void f_wartosc(int, int);
void f_wskaznik(int*);
void f_referencja(int&);
int f_wynik_wartosc(int);

void main()
{ int a;
  a=5;
  clrscr();
  printf("\nwartosc zmiennej a przed wywolaniem funkcji "
         "void f_wartosc(int f_a, int f_b): %d",a);
  f_wartosc(a,7);
  printf("\nwartosc zmiennej a po zakonczeniu wywolanej funkcji: f_wartosc(a,7)"
         " : %d",a);
  getch();
  printf("\n\nwartosc zmiennej a przed wywolaniem funkcji: "
         " void f_wskaznik(int* f_a): %d",a);
  f_wskaznik(&a);
  printf("\nwartosc zmiennej a po zakonczeniu wywolanej funkcji: f_wskaznik(&a)"
         " : %d",a);
  getch();
  printf("\n\nwartosc zmiennej a przed wywolaniem: funkcji"
         " void f_referencja(int& f_a): %d",a);
  f_referencja(a);
  printf("\nwartosc zmiennej a po zakonczeniu wywolanej funkcji: f_referencja(a)"
         " : %d",a);
  getch();
  printf("\n\nwartosc zmiennej a przed wywolaniem funkcji:"
         " int f_wynik_wartosc(int f_a): %d",a);
  a=f_wynik_wartosc(a);
  printf("\nwartosc zmiennej a po przypisaniu wyniku funkcji "
         "czyli: a=f_wynik_wartosc(a): %d",a);
  getch();

}

 void f_wartosc(int f_a, int f_b)
  { //na stosie funkcji umieszczone sa kopie wartosci parametrow
    //aktualnych podstawianych pod: f_a,  f_b
     f_a++; f_b++;
     printf("\nwartosc wyrazenia a++ przekazanego przez wartosc"
            " w czasie dzialania funkcji: %d", f_a);
    printf("\nwartosc wyrazenia ""7++"" przekazanego przez wartosc"
            " w czasie dzialania funkcji: %d", f_b);
  }

 void f_wskaznik(int* f_a)
  { //na stosie funkcji umieszczona jest kopia jawnego adresu parametru
    //aktualnego podstawionego pod f_a;
    //operacje wykonywane sa na parametrze aktualnym (wyluskanym)
     (*f_a)++;
     printf("\nwartosc zmiennej a przekazanej przez wskaznik"
            " w czasie dzialania funkcji: %d",*f_a);
   }

 void f_referencja(int& f_a)
  {//na stosie funkcji umieszczona jest kopia niejawnego adresu parametru
   //aktualnego podstawionego pod f_a;
   //operacje wykonywane sa na parametrze aktualnym
     f_a++;
     printf("\nwartosc zmiennej a przekazanej przez referencje"
            " w czasie dzialania funkcji: %d",f_a);
   }

 int f_wynik_wartosc(int f_a)
  {//na stosie funkcji umieszczona jest kopia wartosci parametru
   //aktualnego podstawionego za f_a
   //wynik dzialania funkcji przekazany jako kopia wartosci parametru
   //aktualnego podstawionego pod f_a
     f_a++;
     printf("\nwartosc zmiennej a przekazanej przez wartosc"
            " w czasie dzialania funkcji: %d",f_a);
     return f_a;
   }